from DecisionTable import *
def eqAction(ActionTab,k1,k2):
    N=len(ActionTab)
    if k1<0 or k1>=N or k2<0 or k2>=N: return False
    for i in range(len(ActionTab[0])):
        if ActionTab[k1][i]!=ActionTab[k2][i]:return False
    return True
def chkCond(CondTab,k1,k2):
    N=len(CondTab)
    if k1<0 or k1>=N or k2<0 or k2>=N: return -2
    NC=0;ID=-1
    for i in range(len(CondTab[0])):
        if CondTab[k1][i]!=CondTab[k2][i]:
            NC+=1;ID=i
            if NC>1: return -2
    return ID
def searchUpdateList(updateList,k):
    for i in range(len(updateList)):
        if updateList[i][0]==k:return updateList[i]
    return []
def chkDtab(CondTab,ActionTab,Debug):
    updateList=[];k1=0;N=len(CondTab)-1
    while k1<N:
        for k2 in range(k1+1,len(CondTab)):
            chk=chkCond(CondTab,k1,k2)
            eqa=eqAction(ActionTab,k1,k2)
            if chk==-1:# すべて条件が同一の場合
                if Debug:
                    if eqa:print("R%dとR%dは冗長です"%(k1,k2))
                    else:print("R%dとR%dは矛盾します"%(k1,k2))
                updateList.append([k2,-1]) # k1を残し，k2を削除
            if chk>0:# 1個だけ異なる
                if CondTab[k1][chk]<0:# k1がDon't care
                    if Debug:
                        if eqa:print("R%dとR%dは冗長です"%(k1,k2))
                        else:print("R%dとR%dは矛盾します"%(k1,k2))
                    updateList.append([k2,-1]) # k1を残し，k2を削除
                elif CondTab[k2][chk]<0:# k2がDon't care
                    if Debug:
                        if eqa:print("R%dとR%dは冗長です"%(k1,k2))
                        else:print("R%dとR%dは矛盾します"%(k1,k2))
                    updateList.append([k1,-1]) # k2を残し，k1を削除
                if (CondTab[k1][chk]>=0 and
                    CondTab[k2][chk]>=0 and eqa):
                    if Debug:
                        print("R%dとR%dのC%dをdon't careにして統合"
                              %(k1,k2,chk))
                    updateList.append([k2,-1])  # k2を削除
                    updateList.append([k1,chk]) # k1とk2を結合
                    k1=k2
                    break
        k1+=1
    Ctab=[]; Atab=[]; updFlag=False
    for k in range(len(CondTab)):# 削除，結合を反映
        upd=searchUpdateList(updateList,k)
        if upd==[]:#変更なければそのまま複写
            Ctab.append(CondTab[k])
            Atab.append(ActionTab[k])
        else:
            updFlag=True;chk=upd[1]
            if chk>=0:#ルール結合
                CondTab[k][chk]=-1
                Ctab.append(CondTab[k])
                Atab.append(ActionTab[k])
    return [Ctab,Atab,updFlag]
def ruleCombine(CondTab,ActionTab,Debug):
    if Debug:print("\n■ルール結合途中経過")
    Ntab=[CondTab,ActionTab]; updFlag=True
    while updFlag:
        if Debug: printDtab(Ntab[0],Ntab[1]);print()
        Ntab=chkDtab(Ntab[0],Ntab[1],Debug)
        updFlag=Ntab[2]
        if Debug: print("変更Flag：",updFlag)
    return Ntab
